Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## mauda.feedback
Class FeedbackKB

    java.lang.Object
      mauda.feedback.FeedbackKB

    public class FeedbackKB

extends java.lang.Object

Knowledge-Base for Feedback-Information.

Author:
  Markus Krebs

Constructor Summary
`FeedbackKB()` Creates a FeedbackKB

Method Summary
`java.util.Vector` | `call(KBFormulaEvaluator evaluator)` Make a call to the knowledge-base for the current-position inside the exercise, and returns all FeedbackKB-Objects its formulas are `true`.
`boolean` | `load(java.lang.String filename)` Loads a knowledge-base from disc.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### FeedbackKB

    public FeedbackKB()

  Creates a FeedbackKB

Method Detail

### load

    public boolean load(java.lang.String filename)

  Loads a knowledge-base from disc.
  The conventions for the knowledge-base-file:
  - Must be a normal txt-file
  - FORMULA: followed by the formula that have to evaluated
  - The next line after FORMULA: must start with MESSAGE: followed by the feedback-message
  - It's possible to write several FORMULA-lines one after another. This describes that the following MESSAGE will be displayed when one of the formulas is true
  - It's possible to write several MESSAGE-lines one after another. This means that the messages will be displayed with a link to the next message
  - The possible formulas are partly plug-in-dependent.
  Conventions for formulas:
  - correct: will be replace by TRUE or FALSE, depends on whether the actual suboperation matches the correct suboperation
  - firstincorrect: will be replaced by TRUE or FALSE, depends whether the actual failure is the first failure inside an operation (like INSERT)
  - missingsubop: will be replaced by TRUE or FALSE, if there are missing suboperations
  - All operators like =, !=, AND, etc. must enclosed in spaces.
  - subop[position]: Represents the SubOperation-Object, where different further access allowed like:
    - id: will be replaced by the ID of the suboperation
    - param1: will be replaced by the 1st parameter of the suboperation
    - param2: will be replaced by the 2nd parameter of the suboperation
  - on param1 and param2 is further access allowed, but this is plugin-dependent.
  Example for an entry:
  `FORMULA: correct AND subop[current].id = newfheapmeld
  MESSAGE: A OPERATION causes to create a new Fibonacci-Heap with a node of the value OPPARAM1 and meld it with the current Fibonacci-Heap.
  MESSAGE: A SUBOPERATION is the correct operation.
  `
  For further information see the dissertation.

  Parameters:
    `filename` - Filename of the knowledge-base-file
  Returns:
    true if loading was successful, false otherwise

### call

    public java.util.Vector call(KBFormulaEvaluator evaluator)

  Make a call to the knowledge-base for the current-position inside the exercise, and returns all FeedbackKB-Objects its formulas are `true`.

  Parameters:
    `evaluator` -
  Returns:
    A Vector of FeedbackKBObject's

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD